/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
2019-05-25: add variables (가구)  
==============================================*/
	program define smart_nastab_add_h_v2  , rclass 
	version 14.0 
	clear 
	set more off
    syntax newvarlist(min=1 max=200 numeric generate)  , [wd(string) website(string)] wave(string) 
	qui cd "`wd'" 
	local v1 "`wave'" 
	return scalar NW=wordcount("`v1'") 
	local NV=wordcount("`varlist'")
	return scalar NV=`NV'
			
					qui foreach v of local v1   {						
							if "`website'"=="" {
								use NaSTaB`v'H, clear			
							}					
							else {					
								use `website'/NaSTaB`v'H, clear		
							}					
						 
						 local add_hhlist ""
						 forvalues i=1/`NV' {
							local a1=substr("``i''",1,1)  
							local a2=substr("``i''",2,.)
							
							    if regexm("``i''","hs") {
										local a1=substr("``i''",1,2)  
										local a2=substr("``i''",3,.)
								}
								
								
							local a3="`a1'"+"`v'"+"`a2'"
							local add_hhlist `add_hhlist' `a3'													 
						 } // forvalues loop 
						 
						rename hid`v' hhid
						drop if hhid==. 
						label var hhid "가구id"
							
							* 2016-11-27에 수정한 부분 
							qui ds
							foreach kk of local add_hhlist {
								if regexm(r(varlist), "`kk'")==0 {
									gen `kk'=.
								}
							}	
							
							keep hhid `add_hhlist'
						
						gen wave="`v'"
						gen wave1=real(wave)
						drop wave
						rename wave1 wave
						capture ren hs`v'* hs*
						capture ren h`v'* h*
						capture ren w`v'* w*
						
						tempfile nastab`v'_add_h_1 
						save "`nastab`v'_add_h_1'", replace 					
													
				}  // v1 loop  (wave loop) 
				
					qui if r(NW)==1 {
					  foreach v of local v1   {
					  use "`nastab`v'_add_h_1'", clear
					  tsset hhid wave 
					  capture drop __*
					  order hhid wave
					  tsset hhid wave
					  compress
					  format hhid %15.0g
					  save nastab_add_h, replace		 
					  }
					}
				
					qui else {
						 local v2=substr("`v1'", 1,2) 
						 use "`nastab`v2'_add_h_1'", clear  
						 local v3=substr("`v1'",4, .)
						 foreach v of local v3  {
							append using "`nastab`v'_add_h_1'" , force 
						 }
						 aorder 
						 order hhid
						 order wave ,after(hhid) 
						 capture drop __*
						 order hhid wave
						 tsset hhid wave
						 compress
						 format hhid %15.0g
						 save nastab_add_h, replace								 
				}
			
					  
	end
	
							