/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
2021.02.15 12차 공식 update
==============================================*/
	program define smart_nastab_h_v2, rclass 
	version 14.0 
	clear 
	set more off
	syntax newvarlist(min=1 max=100 numeric generate) , [wd(string) wide website(string)] wave(string) 	
	qui cd "`wd'" 
	local v1 "`wave'" 
	return scalar NW=wordcount("`v1'") 
	local NV=wordcount("`varlist'")
	return scalar NV=`NV'
		
	qui foreach v of local v1   {
						
			if "`website'"=="" {
				use NaSTaB`v'H, clear					
			}
			
			else {					
				use `website'/NaSTaB`v'H, clear				
			}	
			
	  local h=1
		  foreach head of varlist w`v'rel01 w`v'rel02 w`v'rel03 w`v'rel04 w`v'rel05 w`v'rel06 w`v'rel07 w`v'rel08 w`v'rel09  {
		  tempvar head`h'
		  gen `head`h''= `head' 
		  local ++h
	  }		  
	  
	  local k=1
		  foreach age of varlist w`v'byr01 w`v'byr02 w`v'byr03 w`v'byr04 w`v'byr05 w`v'byr06 w`v'byr07 w`v'byr08 w`v'byr09 {
		  tempvar age`k'
		  rename `age' `age`k''
		  local ++k
	  }
	  	   					
	        forvalues i=1/`NV' {							
			* 1번 
	        if "``i''"=="hage" {
					gen  ``i''=.
					foreach n of num 1/9 {
					replace ``i''=`age`n'' if `head`n''==1									
					}
					
						if "`v'"=="01" {
						replace ``i''=2007-``i''
						}
						else if "`v'"=="02" {
						replace ``i''=2008-``i''
						}
						else if "`v'"=="03" {
						replace ``i''=2009-``i''
						}
						else if "`v'"=="04" {
						replace ``i''=2010-``i''
						}
						else if "`v'"=="05" {
						replace ``i''=2011-``i''
						}
						else if "`v'"=="06" {
						replace ``i''=2012-``i''
						}
						else if "`v'"=="07" {
						replace ``i''=2013-``i''
						}			
						else if "`v'"=="08" {
						replace ``i''=2014-``i''
						}	
						else if "`v'"=="09" {
						replace ``i''=2015-``i''
						}	
						else if "`v'"=="10" {
						replace ``i''=2016-``i''
						}
						else if "`v'"=="11" {
						replace ``i''=2017-``i''
						}
						else if "`v'"=="12" {
						replace ``i''=2018-``i''
						}
						
					recode ``i'' (min/17=.) (105/max=.)    //17세까지는 모두 결측치로 처리 
					label var ``i'' "[가구주] (만)연령"
			}
			
		    * 2번
		    else if "``i''"=="hgen" {
					local j=1
					foreach sex of varlist w`v'gen01 w`v'gen02 w`v'gen03 w`v'gen04 w`v'gen05 w`v'gen06 w`v'gen07 w`v'gen08 w`v'gen09 {
					tempvar sex`j'
					rename `sex' `sex`j''
					local ++j
					}
					   
					gen   ``i''=.
					foreach n of num 1/9 {
					replace ``i''=`sex`n'' if `head`n''==1
					} 
			recode ``i'' (-9=.)		
			label var ``i'' "[가구주] 성별(남=1,여=2)"    
			}
			
			* 3번
		    else if "``i''"=="hmar" {
					local j=1
					foreach sex of varlist w`v'mar01 w`v'mar02 w`v'mar03 w`v'mar04 w`v'mar05 w`v'mar06 w`v'mar07 w`v'mar08 w`v'mar09 {
					tempvar sex`j'
					rename `sex' `sex`j''
					local ++j
					}
					   
					gen   ``i''=.
					foreach n of num 1/9 {
						replace ``i''=`sex`n'' if `head`n''==1						
					}
					
					if "`v'"=="04"| "`v'"=="05"| "`v'"=="06"| "`v'"=="07" | "`v'"=="08" | "`v'"=="09" | "`v'"=="10" | "`v'"=="11" | "`v'"=="12" {
						recode ``i'' (1=1) (2/4=2)
					}
					
					else if "`v'"=="01"| "`v'"=="02"| "`v'"=="03" {
						recode ``i'' (1=1) (3=2)
					}
					
						
					
			recode ``i'' (-9=.)			
			label var ``i'' "[가구주] 작년말 기준 혼인상태(배우자있음=1,배우자없음/미혼=2) "    
			}	
			
			* 4번 
			else if "``i''"=="b10" {
					gen   ``i''=hs`v'b10
					recode ``i'' (-9=.)
					label var ``i'' "[가구] 시도코드"
			}
			*5번 			
			
			* 6번: 가구주 교육수준 
			else if "``i''"=="hedu" {
					local j=1
					foreach sex of varlist w`v'edu01 w`v'edu02 w`v'edu03 w`v'edu04 w`v'edu05 w`v'edu06 w`v'edu07 w`v'edu08 w`v'edu09 {
					tempvar sex`j'
					rename `sex' `sex`j''
					local ++j
					}
					
					local jj=1
					foreach sexx of varlist w`v'grd01 w`v'grd02 w`v'grd03 w`v'grd04 w`v'grd05 w`v'grd06 w`v'grd07 w`v'grd08 w`v'grd09 {
					tempvar sexx`jj'
					rename `sexx' `sexx`jj''
					local ++jj
					}
					
					tempvar aa
					gen `aa'=.
					gen ``i''=.
					
					foreach n of num 1/9 {
						replace ``i''=`sex`n'' if `head`n''==1							
						replace `aa'=`sexx`n'' if `head`n''==1	
					}					
					recode ``i'' (-9=.) (1/3=1) (4=2) (5/max=3) 
					replace ``i''=1 if `aa'~=2 & ``i''==2 
					replace ``i''=2 if `aa'~=2 & ``i''==3 
							
			label var ``i'' "[가구주] 교육수준(1=중졸이하, 2=고졸, 3=전문대졸이상) "    
			}	
			
			* 7번: 가구주 직업 
			else if "``i''"=="hjob" {
					local j=1
					foreach sex of varlist w`v'job01 w`v'job02 w`v'job03 w`v'job04 w`v'job05 w`v'job06 w`v'job07 w`v'job08 w`v'job09 {
					tempvar sex`j'
					rename `sex' `sex`j''
					local ++j
					}
					
					gen   ``i''=.
					foreach n of num 1/9 {
					replace ``i''=`sex`n'' if `head`n''==1						
					}					
					
			recode ``i'' (-9 15=.)	(1/11=1) (12=2) (13=3) (14=4) 		
			label var ``i'' "[가구주] 작년말 기준 직업(1=취업 2=전업주부 3=무직 4=학생 ) "    
			}	
			
			* 8번: 가구주 종사상지위 
			else if "``i''"=="hjpo" {
					local j=1
					foreach sex of varlist w`v'jpo01 w`v'jpo02 w`v'jpo03 w`v'jpo04 w`v'jpo05 w`v'jpo06 w`v'jpo07 w`v'jpo08 w`v'jpo09 {
					tempvar sex`j'
					rename `sex' `sex`j''
					local ++j
					}
					   
					gen   ``i''=.
					foreach n of num 1/9 {
					replace ``i''=`sex`n'' if `head`n''==1						
					}
					
			recode ``i'' (-9=.)	(1=1) (2/3=2) (4/5=3) (6=4) 		
			label var ``i'' "[가구주] 작년말 기준 종사상지위(1=상용직 2=임시/일용직 3=자영업 4=무급가족종사자 ) "    
			}	
			
			
			*8-1번 
			else if "``i''"=="fnum" {
					gen   ``i''=w`v'fnum
					label var ``i'' "[가구] 총 가구원수(명)"
			}
						
			* 9번 : 주택형태 
			else if "``i''"=="ba001" {
					gen   ``i''=h`v'ba001
					recode ``i'' (2=1) (3=2) (1=3) (4/max=4) (-9=.)
					label var ``i'' "[가구] 거주주택의 형태(1=아파트, 2=연립/다세대, 3=단독/다가구 4=기타)"
			}
			
			* 10번 : 점유형태 
			else if "``i''"=="ba002" {
					gen   ``i''=h`v'ba002
					recode ``i'' (1=1) (2=2) (3/4=3) (5/max=4) (-9=.)
					label var ``i'' "[가구] 거주주택의 점유형태(1=자가, 2=전세, 3=월세 4=기타)"
			}
			
			* 11번 : 주택가격 
			else if "``i''"=="ba003" {
					gen   ``i''=h`v'ba003
					recode ``i'' (-9=.)
					label var ``i'' "[가구] 거주주택의 기준시가"
			}
			
			* 12번 : 주택취득연도 
			/*
			else if "``i''"=="house_year" {
					if "`v'"=="05"| "`v'"=="06"| "`v'"=="07" | "`v'"=="08" { 
						gen   ``i''=h`v'ba201
						recode ``i'' (-9=.)
					}
					else {
						gen ``i''=.
					}
										
					label var ``i'' "주택취득년도: 자가인 경우에만 존재함: 5차년도 이후만 존재"
			}
			*/
			* 13번 : 전월세 보증금  
			else if "``i''"=="ba007" {
					gen   ``i''=h`v'ba007
					recode ``i'' (-9=.)
					label var ``i'' "[가구] 거주주택의 전월세 보증금 "
			}
			
			* 14번 : 월세  
			/*
			else if "``i''"=="rent" {
					gen   ``i''=h`v'ba008
					recode ``i'' (-9=.)
					label var ``i'' "월세(단위:만원): 전월세인 경우에만 존재함 "
			}
			*/
			
			* 15번 : 주거면적   : 원래는 ba800 
			else if "``i''"=="hsize" {
					tempvar aa
					gen   `aa'=h`v'ba001
					recode `aa' (2=1) (3=2) (1=3) (4/max=4) (-9=.)
			
					gen   ``i''=h`v'ba011 if `aa'==3								
					replace  ``i''=h`v'ba013 if ``i''==.
					replace  ``i''=h`v'ba045 if ``i''==.
					replace  ``i''=h`v'ba047 if ``i''==.
					recode ``i'' (-9=.)
					label var ``i'' "[가구] 거주주택의 전용 면적(단위: m2) "
			}
			
			* 16번: 재산세 금액 : 5차 ~ 8차만 존재함 
			else if "``i''"=="ba700" {
					if "`v'"=="05"| "`v'"=="06" { 
						mvdecode h`v'ba4*7 h`v'ba4*8 h`v'ba4*9 , mv(-9=.)
						egen ``i''=rowtotal(h`v'ba4*7 h`v'ba4*8 h`v'ba4*9) , miss 						
					}
					else if  "`v'"=="07"| "`v'"=="08"| "`v'"=="09"| "`v'"=="10" | "`v'"=="11" | "`v'"=="12" {
						mvdecode h`v'ba570 h`v'ba572 h`v'ba574 h`v'ba576 h`v'ba578 h`v'ba580 h`v'ba457 h`v'ba458 h`v'ba467 h`v'ba468, mv(-9=.)
						egen ``i''=rowtotal(h`v'ba570 h`v'ba572 h`v'ba574 h`v'ba576 h`v'ba578 h`v'ba580 h`v'ba457 h`v'ba458 h`v'ba467 h`v'ba468) , miss 	
					} 
					else {
						gen ``i''=.
					}
										
					label var ``i'' "[가구] 가구 총 재산세 연간고지금액(단위: 만원)"
			}
	
			* 18번: 자동차 보유 대수 : 0이면 보유 안함 
			else if "``i''"=="bb002" {
					tempvar aa
					gen   `aa'=h`v'bb001
					recode `aa' (1=1) (2=0) (-9=.)
					if "`v'"=="01" | "`v'"=="02" | "`v'"=="03" | "`v'"=="04" {					   
						tempvar h`v'bb003 h`v'bb010 h`v'bb017 h`v'bb024
						
								if "`v'"=="02" | "`v'"=="03"| "`v'"=="04"  {
									gen `h`v'bb003'=h`v'bb003 if h`v'bb151==1
									gen `h`v'bb010'=h`v'bb010 if h`v'bb154==1
									gen `h`v'bb017'=h`v'bb017 if h`v'bb157==1
									gen `h`v'bb024'=h`v'bb024 if h`v'bb160==1
								}
								
								else {
									gen `h`v'bb003'=h`v'bb003
									gen `h`v'bb010'=h`v'bb010 
									gen `h`v'bb017'=h`v'bb017 
									gen `h`v'bb024'=h`v'bb024								
								}
						
						mvdecode `h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024'    , mv(-9=.)
						recode `h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024'   (1/max=1)
						egen ``i''=rowtotal(`h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024'  ) , miss 
					}
					else  {
					    tempvar h`v'bb003 h`v'bb010 h`v'bb017 h`v'bb024 h`v'bb031
							if "`v'"=="08"  {						
								gen `h`v'bb003'=h`v'bb003 if h`v'bb151==1
								gen `h`v'bb010'=h`v'bb010 if h`v'bb154==1 
								gen `h`v'bb017'=h`v'bb017 if h`v'bb157==1
								gen `h`v'bb024'=h`v'bb024 if h`v'bb160==1
								gen `h`v'bb031'=h`v'bb031 if h`v'bb163==1
							}
							else   {						
								gen `h`v'bb003'=h`v'bb003
								gen `h`v'bb010'=h`v'bb010
								gen `h`v'bb017'=h`v'bb017
								gen `h`v'bb024'=h`v'bb024
								gen `h`v'bb031'=h`v'bb031
							}
						
						mvdecode `h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024' `h`v'bb031'   , mv(-9=.)
						recode `h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024' `h`v'bb031'  (1/max=1)
						egen ``i''=rowtotal(`h`v'bb003' `h`v'bb010' `h`v'bb017' `h`v'bb024' `h`v'bb031' ) , miss 
					}
								
					replace ``i''=0 if `aa'==0 
					label var ``i'' "[자동차] 자동차 보유대수(0=보유안함) "
			}			
			
			* 19번 : 1번 자동차 보유 브랜드
			else if "``i''"=="bb003" {
					gen   ``i''=h`v'bb003
					recode ``i'' (-9=.)
					label var ``i'' "[자동차] 첫번째 보유차량 브랜드  "
			}
							
			* 20번: 자동차 연식 
			else if "``i''"=="bb005" {
					gen   ``i''=h`v'bb005
					recode ``i'' (-9=.)
					label var ``i'' "[자동차] 첫번째 보유차량 연식 "
			}
			
			* 21번 : 구입년도
			else if "``i''"=="bb006" {
					gen   ``i''=h`v'bb006
					recode ``i'' (-9=.)
					label var ``i'' "[자동차] 첫번째 보유차량 구입년도  "
			}
			
			* 22번: 구입가격
			else if "``i''"=="bb007" {
					gen   ``i''=h`v'bb007
					recode ``i'' (-9=.)
					label var ``i'' "[자동차] 첫번째 보유차량 구입가격(단위: 만원)"
			}
			* 23번: 유형
			else if "``i''"=="bb101" {
					if "`v'"=="05"| "`v'"=="06"| "`v'"=="07"| "`v'"=="08"| "`v'"=="09" | "`v'"=="10" | "`v'"=="11" | "`v'"=="12" { 
						gen   ``i''=h`v'bb101
						recode ``i'' (-9=.) (1=1) (2=2) (3/max=3)
					}
					else {
						gen ``i''=.
					}										
					label var ``i'' "[자동차] 첫번째 보유차량 유형 (1=휘발유, 2=경우, 3=기타)"
			}
						
			* 24번: 배기량 
			else if "``i''"=="bb008" {
					gen   ``i''=h`v'bb008
					recode ``i'' (-9=.)
					label var ``i'' "[자동차] 첫번째 보유차량 배기량(단위: cc)"
			}
			
			* 25번: 유지비용
			else if "``i''"=="exp_bb" {
					tempvar aa
					gen   `aa'=h`v'bb053
					recode `aa' (1=1) (2=0) (-9=.)
			
					mvdecode h`v'bb201 h`v'bb203 h`v'bb205   , mv(-9=.)
					egen ``i''=rowtotal(h`v'bb201 h`v'bb203 h`v'bb205) , miss 
					replace ``i''=0 if `aa'==0 
					replace ``i''=12*``i''
					label var ``i'' "[지출] 연간 자가차량 유류비 지출 금액(단위: 만원) "
			}
			
			* 26 번: 총 소득 			
			else if "``i''"=="hinc" {
				gen  ``i''=h`v'inc		
				label var ``i'' "[가구] 가구 연간 총 소득(단위: 만원)" 
				
			}	
			*27번 : 총 지출 
			else if "``i''"=="hexp" {
				gen  ``i''=h`v'exp	
				label var ``i'' "[가구] 가구 연간 총 지출(단위: 만원)" 				
			}	
									
			* 26번: 주거비			
			else if "``i''"=="exp_cb" {
					gen  ``i''=h`v'exp_cb	
					label var ``i'' "[지출] 연간 주거비 지출 총액(단위: 만원)  "
			}
			* 27번: 식료품외식비 
			else if "``i''"=="exp_cc" {
					gen  ``i''=h`v'exp_cc	
					label var ``i'' "[지출] 연간 식료품/외식비 지출 총액(단위: 만원) "
			}
			
			
			* 28번: 주류비
			else if "``i''"=="exp_cd" {
				gen  ``i''=h`v'exp_cd											
				label var ``i'' "[지출] 연간 주류비 지출 총액(단위: 만원)  "
			}
			
			* 29번: 담배구입비
			else if "``i''"=="exp_ce" {
					gen  ``i''=h`v'exp_ce
					label var ``i'' "[지출] 연간 담배구입비 지출 총액(단위: 만원)  "
			}
			
			* 29-1번: 교통비
			else if "``i''"=="exp_cf" {					
					gen  ``i''=h`v'exp_cf
					label var ``i'' "[지출] 연간 교통비 지출 총액(단위: 만원)   "
			}
			
			* 30번: 통신비
			else if "``i''"=="exp_cg" {
					gen  ``i''=h`v'exp_cg
					label var ``i'' "[지출] 연간 통신비 지출 총액(단위: 만원)  "
			}
							
			* 31번: 문화생활비
			else if "``i''"=="exp_ch" {
				gen  ``i''=h`v'exp_ch
				label var ``i'' "[지출] 연간 문화생활비 지출 총액(단위: 만원)"
			}
			
						
			* 33번: 교육비
			else if "``i''"=="exp_co" {
					gen  ``i''=h`v'exp_co
					label var ``i'' "[지출] 연간 교육비 지출 총액(단위: 만원)  "
			}
			
			* 34번: 보건의료비
			else if "``i''"=="exp_cp" {
					gen  ``i''=h`v'exp_cp
					label var ``i'' "[지출] 연간 보건의료비 지출 총액(단위: 만원) "
			}
					
			* 35번: 기부금
			else if "``i''"=="exp_cr" {
					gen  ``i''=h`v'exp_cr
					label var ``i'' "[지출] 연간 기부금 지출 총액(단위: 만원) "
			}
			
			* 36번: 가전제품  구입
			else if "``i''"=="exp_ci" {
					gen  ``i''=h`v'exp_ci
					label var ``i'' "[지출] 연간 가전제품 구입 지출 총액(단위: 만원) "
			}
			
			* 37번: 통신장비 
			else if "``i''"=="exp_cj" {
					gen  ``i''=h`v'exp_cj
					label var ``i'' "[지출] 연간 통신장비 구입 지출 총액(단위: 만원)"
			}
					
			* 38번: 가구 악기 
			else if "``i''"=="exp_ck" {
					gen  ``i''=h`v'exp_ck
					label var ``i'' "[지출] 연간 가구악기스포츠장비 구입 지출 총액(단위: 만원) "
			}
			
			* 39번: 의류 잡화 
			else if "``i''"=="exp_cl" {
					gen  ``i''=h`v'exp_cl
					label var ``i'' "[지출] 연간 의류잡화 구입 지출 총액(단위: 만원) "
			}
			
			* 40번: 화장품 
			else if "``i''"=="exp_cm" {
					gen  ``i''=h`v'exp_cm
					label var ``i'' "[지출] 연간 화장품 및 이미용비 지출 총액(단위: 만원) "
			}
					
			* 41번: 여행 
			else if "``i''"=="exp_cn" {
					gen  ``i''=h`v'exp_cn
					label var ``i'' "[지출] 연간 여행 관련 지출 총액(단위: 만원) "
			}
			
			* 42번: 혼인 장례 
			else if "``i''"=="exp_cq" {
					gen  ``i''=h`v'exp_cq
					label var ``i'' "[지출] 연간 혼인장례이사 지출 총액(단위: 만원) "
			}
			
			* 43번: 가사 도우미 
			else if "``i''"=="exp_cs" {
					gen  ``i''=h`v'exp_cs
					label var ``i'' "[지출] 연간 가사도우미 서비스 지출 총액(단위: 만원)"
			}
					
			* 44번: 민간보험료 
			else if "``i''"=="exp_ct" {
					gen  ``i''=h`v'exp_ct
					label var ``i'' "[지출] 연간 민간보험료 지출 총액(단위: 만원)"
			}
			* 45번: 건강보험료 
			else if "``i''"=="exp_cu" {
					gen  ``i''=h`v'exp_cu
					label var ``i'' "[지출] 연간 건강보험료 지출 총액(단위: 만원) "
			}
						
			* 46번: 금융자산
			else if "``i''"=="asset_fa" {
				if "`v'"=="01"  {
					tempvar aa bb cc dd ee ff gg 
					gen   `aa'=h`v'fa001
					gen   `bb'=h`v'fa003
					gen   `cc'=h`v'fa005
					gen   `dd'=h`v'fa007
					gen   `ee'=h`v'fa011
					gen   `ff'=h`v'fa013
					gen   `gg'=h`v'fa015					
					
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' (1=1) (2=0) (-9=.)
					mvdecode h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa012 h`v'fa014 h`v'fa016   , mv(-9=.)
					egen ``i''=rowtotal(h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa012 h`v'fa014 h`v'fa016  ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 
				}
				
				else  if "`v'"=="02" | "`v'"=="03" |"`v'"=="04" |"`v'"=="05" |"`v'"=="06" |"`v'"=="07" |"`v'"=="08"  {
					tempvar aa bb cc dd ee ff gg hh 
					gen   `aa'=h`v'fa001
					gen   `bb'=h`v'fa003
					gen   `cc'=h`v'fa005
					gen   `dd'=h`v'fa007
					gen   `ee'=h`v'fa009
					gen   `ff'=h`v'fa011
					gen   `gg'=h`v'fa013
					gen   `hh'=h`v'fa015					
												
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh'  (1=1) (2=0) (-9=.)
					mvdecode h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa010 h`v'fa012 h`v'fa014 h`v'fa016 , mv(-9=.)
					egen ``i''=rowtotal(h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa010 h`v'fa012 h`v'fa014 h`v'fa016 ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 
				}	
				
				else  {
					tempvar aa bb cc dd ee ff gg hh ii
					gen   `aa'=h`v'fa001
					gen   `bb'=h`v'fa003
					gen   `cc'=h`v'fa005
					gen   `dd'=h`v'fa007
					gen   `ee'=h`v'fa009
					gen   `ff'=h`v'fa011
					gen   `gg'=h`v'fa013
					gen   `hh'=h`v'fa015
					gen   `ii'=h`v'fa017
												
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh' `ii' (1=1) (2=0) (-9=.)
					mvdecode h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa010 h`v'fa012 h`v'fa014 h`v'fa016 h`v'fa018 , mv(-9=.)
					egen ``i''=rowtotal(h`v'fa002 h`v'fa004 h`v'fa006 h`v'fa008 h`v'fa010 h`v'fa012 h`v'fa014 h`v'fa016 h`v'fa018  ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 & `ii'==0
				}	
				
					label var ``i'' "[자산] 금융자산(단위: 만원) "
			}
			
			* 39번: 부동산 자산 
			else if "``i''"=="asset_fb" {
				if "`v'"=="01"   {
					tempvar aa bb cc dd ee ff gg hh ii 
					gen   `aa'=h`v'fb030
					gen   `bb'=h`v'fb009
					gen   `cc'=h`v'fb011
					gen   `dd'=h`v'fb013
					gen   `ee'=h`v'fb015
					gen   `ff'=h`v'fb017
					gen   `gg'=h`v'fb025
					gen   `hh'=h`v'fb019
					gen   `ii'=h`v'fb001
					
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh' `ii' (1=1) (2=0) (-9=.)
					mvdecode h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb016 h`v'fb020 ///
					, mv(-9=.)
					egen ``i''=rowtotal(h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb016 h`v'fb020  ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 & `ii'==0
				}
				else if "`v'"=="02" | "`v'"=="03" | "`v'"=="04" {
					tempvar aa bb cc dd ee ff gg hh ii jj kk ll
					gen   `aa'=h`v'fb030
					gen   `bb'=h`v'fb009
					gen   `cc'=h`v'fb011
					gen   `dd'=h`v'fb013
					gen   `ee'=h`v'fb015
					gen   `ff'=h`v'fb017
					gen   `gg'=h`v'fb025
					gen   `hh'=h`v'fb019
					gen   `ii'=h`v'fb001
					gen   `jj'=h`v'fb003
					gen   `kk'=h`v'fb005
					gen   `ll'=h`v'fb007
					
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh' `ii' `jj' `kk' `ll' (1=1) (2=0) (-9=.)
					mvdecode h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb016 h`v'fb020 ///
					h`v'fb004 h`v'fb006 h`v'fb008, mv(-9=.)
					egen ``i''=rowtotal(h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb016 h`v'fb020 h`v'fb004 h`v'fb006 h`v'fb008 ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 & `ii'==0& `jj'==0 & `kk'==0 & `ll'==0
				
				}
				else if "`v'"=="05" |"`v'"=="06" |"`v'"=="07" |"`v'"=="08"|"`v'"=="09"|"`v'"=="10" {
					tempvar aa bb cc dd ee ff gg hh ii jj kk ll mm nn
					gen   `aa'=h`v'fb030
					gen   `bb'=h`v'fb009
					gen   `cc'=h`v'fb011
					gen   `dd'=h`v'fb021
					gen   `ee'=h`v'fb023
					gen   `ff'=h`v'fb013
					gen   `gg'=h`v'fb015
					gen   `hh'=h`v'fb017
					gen   `ii'=h`v'fb025
					gen   `jj'=h`v'fb019
					gen   `kk'=h`v'fb001
					gen   `ll'=h`v'fb003
					gen   `mm'=h`v'fb005
					gen   `nn'=h`v'fb007
					
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh' `ii' `jj' `kk' `ll' `mm' `nn' (1=1) (2=0) (-9=.)
					mvdecode h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb022 h`v'fb024 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb026 h`v'fb020 ///
					h`v'fb002 h`v'fb004 h`v'fb006 h`v'fb008 , mv(-9=.)
					egen ``i''=rowtotal(h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb022 h`v'fb024 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb026 h`v'fb020 ///
					h`v'fb002 h`v'fb004 h`v'fb006 h`v'fb008 ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 & `ii'==0 & `jj'==0 & `kk'==0 ///
					& `ll'==0 & `mm'==0 & `nn'==0
				}
				
				else if "`v'"=="11" | "`v'"=="12" {
					tempvar aa bb cc dd ee ff gg hh ii jj kk ll mm nn oo
					gen   `aa'=h`v'fb030
					gen   `bb'=h`v'fb009
					gen   `cc'=h`v'fb011
					gen   `dd'=h`v'fb021
					gen   `ee'=h`v'fb023
					gen   `ff'=h`v'fb013
					gen   `gg'=h`v'fb015
					gen   `hh'=h`v'fb017
					gen   `ii'=h`v'fb025
					gen   `jj'=h`v'fb019
					gen   `kk'=h`v'fb001
					gen   `ll'=h`v'fb003
					gen   `mm'=h`v'fb005
					gen   `nn'=h`v'fb007
					gen   `oo'=h`v'fb041
					
					recode `aa' `bb' `cc' `dd' `ee' `ff' `gg' `hh' `ii' `jj' `kk' `ll' `mm' `nn' `oo'(1=1) (2=0) (-9=.)
					mvdecode h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb022 h`v'fb024 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb026 h`v'fb020 ///
					h`v'fb002 h`v'fb004 h`v'fb006 h`v'fb008 h`v'fb042, mv(-9=.)
					egen ``i''=rowtotal(h`v'fb031 h`v'fb010 h`v'fb012 h`v'fb022 h`v'fb024 h`v'fb014 h`v'fb016 h`v'fb018 h`v'fb026 h`v'fb020 ///
					h`v'fb002 h`v'fb004 h`v'fb006 h`v'fb008 h`v'fb042), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0 & `hh'==0 & `ii'==0 & `jj'==0 & `kk'==0 ///
					& `ll'==0 & `mm'==0 & `nn'==0& `oo'==0
				}
												
					label var ``i'' "[자산] 부동산 자산 및 기타자산(단위: 만원)  "
			}
			
			* 40번: 부채 총액
			else if "``i''"=="debt_fc" {
			
				if "`v'"=="01"| "`v'"=="02" {
					tempvar aa bb cc dd ee 
					gen   `aa'=h`v'fc002
					gen   `bb'=h`v'fc005
					gen   `cc'=h`v'fc011
					gen   `dd'=h`v'fc014
					gen   `ee'=h`v'fc016
												
					recode `aa' `bb' `cc' `dd' `ee' (1=1) (2=0) (-9=.)
					mvdecode h`v'fc003 h`v'fc006 h`v'fc012 h`v'fc015 h`v'fc017 , mv(-9=.)
					egen ``i''=rowtotal(h`v'fc003 h`v'fc006 h`v'fc012 h`v'fc015 h`v'fc017 ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 
				}
				
				else if "`v'"=="03"| "`v'"=="04" {
					tempvar aa bb cc dd ee ff 
					gen   `aa'=h`v'fc002
					gen   `bb'=h`v'fc005
					gen   `cc'=h`v'fc008
					gen   `dd'=h`v'fc011
					gen   `ee'=h`v'fc014
					gen   `ff'=h`v'fc016
												
					recode `aa' `bb' `cc' `dd' `ee' `ff' (1=1) (2=0) (-9=.)
					mvdecode h`v'fc003 h`v'fc006 h`v'fc009 h`v'fc012 h`v'fc015 h`v'fc017, mv(-9=.)
					egen ``i''=rowtotal(h`v'fc003 h`v'fc006 h`v'fc009 h`v'fc012 h`v'fc015 h`v'fc017 ), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 
				}
				
				else if "`v'"=="05"|"`v'"=="06"| "`v'"=="07"| "`v'"=="08"| "`v'"=="09"| "`v'"=="10"| "`v'"=="11"| "`v'"=="12"   {
					tempvar aa bb cc dd ee ff gg 
					gen   `aa'=h`v'fc002
					gen   `bb'=h`v'fc005
					gen   `cc'=h`v'fc008
					gen   `dd'=h`v'fc011
					gen   `ee'=h`v'fc014
					gen   `ff'=h`v'fc016
					gen   `gg'=h`v'fc018
												
					recode `aa' `bb' `cc' `dd' `ee' `ff' (1=1) (2=0) (-9=.)
					mvdecode h`v'fc003 h`v'fc006 h`v'fc009 h`v'fc012 h`v'fc015 h`v'fc017 h`v'fc019, mv(-9=.)
					egen ``i''=rowtotal(h`v'fc003 h`v'fc006 h`v'fc009 h`v'fc012 h`v'fc015 h`v'fc017 h`v'fc019), miss
					replace ``i''=0 if `aa'==0 & `bb'==0 & `cc'==0 & `dd'==0 & `ee'==0 & `ff'==0 & `gg'==0
				}					
					
					label var ``i'' "[부채]부채총액 (단위: 만원) "
			}   
					
			
			* 41 번 : 횡단면 가중치
			else if "``i''"=="hcw" {
				gen  ``i''=h`v'cwt			
				label var ``i'' "[가구] 횡단면 가중치" 
			}
			
			* 42번: 종단면 가중치 
			else if "``i''"=="hlw" {
			    if "`v'"~="01" {
					gen  ``i''=h`v'lwt
				}
				
				else {
					gen ``i''=.
				}
				label var ``i'' "[가구] 종단면 가중치 " 
			}
			
			
			
			* error message 
		    else {
				di as err "``i'' NOT appear on the new variable list" 
			}
				
		}   // the end of "i" loop			
							
			gen wave="`v'"
			gen wave1=real(wave)
			drop wave
			rename wave1 wave 
			label var wave "서베이차수" 
		    gen year=wave+2006
			label var year "조사년도"
			rename hid`v' hhid
			drop if hhid==. 
			label var hhid "가구id"  
			keep hhid wave year `varlist'
			ren * h_*
			ren (h_hhid h_year h_wave) (hhid year wave)
	        			
	tempfile koweps`v'h_1 
	save "`koweps`v'h_1'", replace 
	}	
	
	qui if r(NW)==1 {
		  foreach v of local v1   {
		  use "`koweps`v'h_1'", clear
		  tsset hhid wave 
		  capture drop __*
		  order hhid wave
		  tsset hhid wave
		  compress
		  format hhid %15.0g
		  save nastab_h_final, replace		 
		 }
	}
	
	qui else {
			 local v2=substr("`v1'", 1,2) 
			 use "`koweps`v2'h_1'", clear 
			 local v3=substr("`v1'",4, .)
			 foreach v of local v3  {
				append using "`koweps`v'h_1'" , force 
			 }
			 aorder 
			 order hhid
			 order wave year ,after(hhid) 
			 capture drop __*
			 order hhid wave
			 tsset hhid wave
			 compress
			 format hhid %15.0g
			 save nastab_h_final, replace 		     
		    			 
	}		
			
	if "`wide'"=="wide" {
		capture drop year 
		reshape wide h_* , i(hhid) j(wave)
		aorder 
		order hhid
		capture drop __*
		compress
		save nastab_h_final_`wide', replace 
	}	
	
	end 
	 
 